const { createElement, render, useState,useEffect,Fragment} = wp.element;


const QuestionList = (props) => {

	const [quiz,setQuiz] = useState({});
	const [currentQuestions,setCurrentQuestions] = useState([]);

	useEffect(()=>{
		setQuiz(props.quiz);
		setCurrentQuestions(props.currentQuestions);
	},[props.quiz,props.currentQuestions]);
	
	

	const loadQuestion = (e,question,index)=>{
		e.preventDefault();
		let ncurrentQuestions = [...currentQuestions];
		let newcurrentQuestions = [];
		if(quiz.question_number && quiz.question_number != 'undefined' && quiz.question_number > 0){
			if(ncurrentQuestions.indexOf(index) !== -1){
				return;
			}

			let part_no = Math.ceil((index+1)/quiz.question_number);
			let start_length = (part_no*quiz.question_number)-quiz.question_number;
			let end_length = part_no*quiz.question_number;
			
			for(let i=start_length;i<end_length;i++){
				newcurrentQuestions.push(i);
			}
			setCurrentQuestions(newcurrentQuestions);

		}
		
		props.update(newcurrentQuestions,'show');
	}

	return (
		<div className="quiz_timeline">
			<div class="timeline_wrapper">
	            <ul>
				{
					(quiz && quiz.meta && quiz.meta.questions && quiz.meta.questions.length)?
					quiz.meta.questions.map((question,i)=>{
						let done = '';
						if(question['marked_answer'] != 'undefined' && question['marked_answer'] != null || (Array.isArray(question['marked_answer']) && question['marked_answer'].length)){
							done = 'done';
						}
						if(currentQuestions.indexOf(i) !== -1){
							done = done+' active';
						}
						return <li className={done}>
							<span></span>
							<a href="#" className="" onClick={(e)=>{loadQuestion(e,question,i);}}>
								{ window.wplms_quiz_data.translations.question+' '+(i+1) }
								<span>{question.marks}</span>
							</a>
						</li>
					})
					
					:''
				}
				</ul>
			</div>
		</div>
	  
	);
}
export default QuestionList;