const { createElement, render, useState,useEffect,Fragment} = wp.element;

const Sortable = (props) => {

	const [blocks,setBlocks] = useState([]);
	const [isDrag,setisDrag] = useState(false);
	const [items,setItems] = useState([]);
	const [draggeditems,setdraggeditems] = useState([]);
	const [touchMovements,setTouchMovements] = useState([]);
	const [style, setStyle] = useState([]);

	useEffect(()=>{
		setItems(props.items);

	},[props.items]);


	const getRef = (ref, i) => {
		if(ref){
			let nblocks = blocks;
			if(!nblocks[i]){
				nblocks[i] = ref;
			}
		    setBlocks(nblocks);
		}
		
  	};

  	const dragOver = (e,i) =>{
  		if(!isDrag)
  			return;
  		let draggedOverItem = items[i];

  		if (isDrag === draggedOverItem) {
	      return;
	    }
  		let nitems = [...items];

  		nitems = nitems.filter(item => item != isDrag);
  		
	    nitems.splice(i, 0,isDrag);
	    
  		setItems(nitems);
  		props.update(nitems,'changed');
  	}

  	let classs = 'droppable';
  	if(isDrag){
  		classs +=' active';
  	}

  	const dragging = (i) =>{
  		let rr = '';
  		if(isDrag === items[i]){
  			rr ='dragging';
  		}
  		return rr;	
  	}

	return (
		<div className={classs}>
			{
				items.map((item,i) => {
		          	return (
		          		<div key={i}
			          	onDragStart={(e)=>{
			          		if(items[i]){
			          			setisDrag(items[i]);
			          		}
			          	}} 
			          	onDragEnd={()=>{setisDrag(false)}} 
			          	onDragOver={(e)=>{e.preventDefault();dragOver(e,i)}} 
			          	
			          	ref={(e)=>{getRef(e,i);}} 
			          	draggable="true" 
			          	style={style[i]}
			          	onTouchStart={(e)=>{
			          		//if(!touchMovements.length){
			          			let ntouchMovements = [...touchMovements];
				          		blocks.map((block,index)=>{
				          			let rect = block.getBoundingClientRect();
				          			ntouchMovements[index] = rect;
				          		});
				          		setTouchMovements(ntouchMovements);
			          		//}
			          		if(items[i]){
			          			setisDrag(items[i]);
			          		}
			          	}}
			          	onTouchMove={(e)=>{ 
			          		e.preventDefault();

			          		let nitems = [];
			          		
        					if (e.type === "touchmove") {

        						let mystyle =[...style];
        						mystyle[i]={transform:'translateY('+Math.floor(e.touches[0].clientY - touchMovements[i].top)+'px)'};
        						setStyle(mystyle);

        						nitems.push(items[i]);
        						let topItems=  [];
        						if(e.touches[0].clientY){
        							touchMovements.map((touchMovement,index)=>{
									
										if(touchMovement.top + (touchMovement.height/2) > e.touches[0].clientY){
	    									if(items[index] !== items[i]){
	    										nitems.push(items[index]);
	    									}
	    								}

	    								if(touchMovement.bottom-(touchMovement.height/2) < e.touches[0].clientY){
	    									if(items[index] !== items[i]){
	    										topItems.push(items[index]);
	    									}
	    								}


	    							});
        						}
								

								if(topItems.length){
									for(let k=(topItems.length-1);k>=0;k--){
										nitems.unshift(topItems[k]);
									}
								}
								setdraggeditems(nitems);
								
			          		}
			          	}}
			          	onTouchEnd={(e)=>{setItems(draggeditems);props.update(draggeditems,'changed');setTouchMovements([]);setStyle([]); setisDrag(false);setdraggeditems([]);}}
			          	className={dragging(i)+' '+((props.question.show_correct_answer)?((props.question.correct_indexes)?(props.question.correct_indexes && props.question.correct_indexes.length && props.question.correct_indexes.includes(i))?'question_correct':'question_incorrect':''):'')}
			          	>
			          		<div dangerouslySetInnerHTML={{__html:item}}></div>
		          		</div>
		          	)
		        })
			}
		</div>
	)
}

export default Sortable;