import CryptoJS from './../libs/crypto.js';
import CryptoJSAesJson from './cryptoaes.js';
import getUserMarkedAnswer from './usermarkedanswer.js';
import getCorrectAnswer from './showcorrectanswer.js';
function isEmpty(obj){
    if (obj == null) return true;
    if (typeof obj === 'undefined') return true;
    if (typeof obj == 'number') return false;
    if (Array.isArray(obj) || typeof obj === 'string' || obj instanceof String) return obj.length === 0;
    for (var key in obj) if (obj.hasOwnProperty(key)) return false;
    return true;
}
const evaluatequestion = (question,partialMarking=null,negativeMarking=null,negativeMarks=null,force_evaluate=true) => {
    if(negativeMarks){
        negativeMarks = parseFloat(negativeMarks);
    }
    if(!negativeMarking){
        negativeMarks = null;
    }
    let userCorrect = 0;
    let correct_indexes = [];
    let user_marked_correct_answers = 0;
    question.user_marks = 0;
    let incorrect_options = 0;
    let question_correct = null;
    if(!isEmpty(question.correct)){
        question_correct = JSON.parse(CryptoJS.AES.decrypt(question.correct, question.key, {format: CryptoJSAesJson}).toString(CryptoJS.enc.Utf8));
    }
    question.correct = question_correct; 
    if(!(question['marked_answer'] && question['marked_answer'] != 'undefined') ){
        question['marked_answer'] = null;
    }
    let answer = question['marked_answer'];
    switch(question.type){
        case 'truefalse':
            question.marked = answer;
            question.correct = parseInt(question_correct);
            if(answer == question_correct){
                question.user_marks = question.marks;
                userCorrect = 1;
            }else{
                question.user_marks = 0;
            }
            correct_indexes.push(question_correct);
        break;
        case 'single':
            question.marked = answer;
            if(answer == (question_correct - 1)){
                question.user_marks = question.marks;
                userCorrect = 1;
            }else{
                question.user_marks = 0;
            }
            correct_indexes.push((question_correct - 1));
        break;
        case 'multiple':
            if(isEmpty(answer)){
                answer = [];
            }
            var ans = answer;
            question.marked=answer.join(',').slice();
            var correct = question_correct.split(',');
            correct_indexes = correct;
            if(partialMarking){
                if(ans.length){
                    for(let k=0;k<ans.length;k++){
                        //question.user_marks = question.marks;
                        let match = (ans[k]+1);
                        match = match.toString();
                        
                        if(correct.indexOf(match) !== -1){
                            user_marked_correct_answers++;
                        }else{
                            incorrect_options++;
                        }
                    }
                }
                userCorrect = (user_marked_correct_answers/correct.length);
                question.user_marks = Math.round((question.marks*userCorrect) * 100) / 100;
            }else{
                if((ans.length) == correct.length){
                    for(let k=0;k<ans.length;k++){
                        question.user_marks = question.marks;
                        userCorrect = 1;
                        let match = (ans[k]+1);
                        match = match.toString();
                       
                        if(correct.indexOf(match) == -1){
                            question.user_marks = 0;
                            userCorrect = 0;
                            break;
                        }
                    }
                }
            }

            
        break;
        case 'match':
        case 'sort':
            if(isEmpty(answer)){
                answer = [];
            }
            question.marked=answer.join(',').slice();
            let match_ans = answer;
            let match_correct = question_correct.split(',');
            /*if(partialMarking){
                if(match_ans && match_ans.length){
                    for(let k=0;k<match_ans.length;k++){
                        let match='';
                        if(match_ans[k] && match_ans[k] != 'undefined'){
                            match = match_ans[k].toString();
                        }
                        if(match_correct[k] == match){
                            user_marked_correct_answers++;
                            correct_indexes.push(k);
                        }
                    }
                }
                userCorrect = (user_marked_correct_answers/match_correct.length);
                question.user_marks = Math.round((question.marks*userCorrect) * 100) / 100;
            }else{*/
                let EvenOneIsWrong = 0;
                if(match_ans && match_ans.length){
                    for(let k=0;k<match_ans.length;k++){
                        question.user_marks = question.marks;
                        userCorrect = 1;
                        let match='';
                        if(!isEmpty(match_ans[k]))
                            match = match_ans[k].toString();
                        if(match_correct[k] != match){
                            if(userCorrect){
                                question.user_marks = 0;
                                userCorrect = 0;
                                EvenOneIsWrong = 1;
                            }
                            incorrect_options++;
                        }else{
                            user_marked_correct_answers++;
                            correct_indexes.push(k);
                        }
                    }

                    if(partialMarking){
                        userCorrect = (user_marked_correct_answers/match_correct.length);
                        question.user_marks = Math.round((question.marks*userCorrect) * 100) / 100;
                    }else{
                        
                        if(EvenOneIsWrong){
                            question.user_marks = 0;
                            userCorrect = 0;
                        }
                    }
                   
                }
            //}
        break;
        case 'fillblank':
            if(isEmpty(answer)){
                answer = [];
            }
            answer.map((a,i)=>{
                answer[i] = a.toLowerCase();
            });
            question.marked=answer.join('|').slice();
            question_correct = question_correct.toLowerCase();
            let fill_correct = question_correct.split('|');
            question.user_marks = 0;
            /*if(partialMarking){
                if(answer.length){

                    for(let k=0;k<answer.length;k++){
                        let match='';
                        if(answer[k])
                            match = answer[k].toString();
                        let fill_variants = fill_correct[k].split(',');
                        if(fill_variants.indexOf(match) !== -1){
                            user_marked_correct_answers++;
                            correct_indexes.push(k);
                        }
                    }
                }
                userCorrect = (user_marked_correct_answers/fill_correct.length);
                question.user_marks = Math.round((question.marks*userCorrect) * 100) / 100;
            }else{*/
                //if(fill_correct.length == answer.length){
                if(answer.length){
                    question.user_marks = question.marks;
                    userCorrect = 1;
                    for(let k=0;k<answer.length;k++){
                        let match='';
                        if(!isEmpty(answer[k]))
                            match = answer[k].toString();
                        let fill_variants = [];
                        if(!isEmpty(fill_correct[k]) && !Array.isArray(fill_correct[k])){
                             fill_variants = fill_correct[k].split(',');
                        }
                        
                        if(fill_variants.indexOf(match) == -1){
                            if(userCorrect){
                                question.user_marks = 0;
                                userCorrect = 0;
                            }
                            incorrect_options++;
                        }else{
                            user_marked_correct_answers++;
                            correct_indexes.push(k);
                        }
                    }
                    if(partialMarking){
                        
                        userCorrect = (user_marked_correct_answers/fill_correct.length);
                        question.user_marks = Math.round((question.marks*userCorrect) * 100) / 100;
                    }else{
                        if(answer.length !== fill_correct.length){
                            question.user_marks = 0;
                            userCorrect = 0;
                        }
                    }
                }
                //}
            //}
            
            
        break;
        case 'select':
            if(isEmpty(answer)){
                answer = [];
            }
            question.marked=answer.join('|').slice();
            let select_correct = question_correct.split('|');
            question.user_marks = 0;
            /*if(partialMarking){
                if(answer.length){

                    for(let k=0;k<answer.length;k++){
                        let match='';
                        match = (parseInt(answer[k])+1).toString();
                        
                        if(match == select_correct[k]){
                            user_marked_correct_answers++;
                            correct_indexes.push(k);
                        }
                    }
                }
                userCorrect = (user_marked_correct_answers/select_correct.length);
                question.user_marks = Math.round((question.marks*userCorrect) * 100) / 100;
            }else{*/
                //if(select_correct.length == answer.length){
                if(answer && answer.length){
                    question.user_marks = question.marks;
                    userCorrect = 1;
                    for(let k=0;k<answer.length;k++){
                        let match='';
                        match = (parseInt(answer[k])+1).toString();
                        
                        if(match != select_correct[k]){
                            if(userCorrect){
                               question.user_marks = 0;
                                userCorrect = 0; 
                            }
                            incorrect_options++;
                        }else{
                            user_marked_correct_answers++;
                            correct_indexes.push(k);
                        }
                    }
                    if(partialMarking){
                       
                        userCorrect = (user_marked_correct_answers/select_correct.length);
                        question.user_marks = Math.round((question.marks*userCorrect) * 100) / 100;
                    }else{
                        if(answer.length !== select_correct.length){
                            question.user_marks = 0;
                            userCorrect = 0;
                        }
                    }
                }
                //}
            //}
            
        break;
        case 'smalltext':
        case 'largetext':
            question.marked = answer;
            if(answer && question_correct && answer.toLowerCase() == question_correct.toLowerCase()){
                question.user_marks = question.marks;
                userCorrect = 1;
            }else{
                question.user_marks = 0;
            }
        break;
        default:
        break;
    }

    if(!isEmpty(answer)  && negativeMarks){
        if(partialMarking && incorrect_options>0){
            
            question['user_marks'] = question['user_marks'] - (incorrect_options*negativeMarks);
        }else{
            if(!userCorrect){
                
                question['user_marks'] = question['user_marks'] - negativeMarks;
            }
        }
    }

    if(!question.auto && !force_evaluate){
        question['user_marks'] = 0;
        question['show_correct_answer'] = 0;
    }

    if(correct_indexes && correct_indexes.length){
        for (var i = correct_indexes.length - 1; i >= 0; i--) {
            if(question.type == 'multiple'){
                correct_indexes[i] = parseInt((correct_indexes[i]-1));
            }else{
                correct_indexes[i] = parseInt(correct_indexes[i]);
            }
        }
    }
    question['correct_indexes'] = correct_indexes;
    if(question.auto){
        question['usercorrect'] = userCorrect;
        question['attempted'] = true;
    }
    
    //to show processed marked answer instead of indexes and arrays
    question['marked']  = getUserMarkedAnswer(question);
    question['correct']  = getCorrectAnswer(question);
    return question;
}
    


export default evaluatequestion;