const getCorrectAnswer = (question) => {
    let answer='';
    if(!question.type)
    	return '';
    switch(question.type){
        case 'truefalse':
            if(question.correct){
                answer = window.wplms_quiz_data.translations.true;
            }else{
                answer = window.wplms_quiz_data.translations.false;
            }
        break;
        case 'single':
        case 'survey':
            answer = question.options[(parseInt(question.correct)-1)];
        break;
        case 'multiple':
            answer = '';
            
            var correct = question.correct.split(',');
            if(correct.length){
                for(let i=0;i<correct.length;i++){
                    
                    answer += question.options[(parseInt(correct[i])-1)]+(((i+1) < correct.length)?' , ':'');
                }
            }
        break;
        case 'sort':
        case 'match':
            answer = '';
            
            var correct = question.correct.split(',');
            if(correct.length){
                for(let i=0;i<correct.length;i++){
                    
                    answer += question.original_options[(parseInt(correct[i])-1)]+(((i+1) < correct.length)?' , ':'');
                }
            }
        break;
        case 'select':
            answer = '';
            var correct = question.correct.split('|');
            if(correct.length){
                for(let i=0;i<correct.length;i++){
                    answer += question.options[(parseInt(correct[i])-1)]+(((i+1) < correct.length)?' , ':'');
                }
            }
        break;
        case 'fillblank':
        case 'text':
        case 'largetext':
        case 'smalltext':
            answer = '';
            var correct = question.correct.split('|');
            if(correct.length){
                for(let i=0;i<correct.length;i++){
                    answer += correct[i]+(((i+1) < correct.length)?' , ':'');
                }
            }
        break;
    }
    return answer;
}

export default getCorrectAnswer;